/// <reference types="node" />
import { PathLike } from 'fs';
import { TypeAliases, Idl } from './types';
import { Options } from 'prettier';
export * from './types';
export declare class Solita {
    private readonly idl;
    private readonly formatCode;
    private readonly formatOpts;
    private readonly accountsHaveImplicitDiscriminator;
    private readonly prependGeneratedWarning;
    private readonly typeAliases;
    private paths;
    constructor(idl: Idl, { formatCode, formatOpts, prependGeneratedWarning, typeAliases: aliases, }?: {
        formatCode?: boolean;
        formatOpts?: Options;
        prependGeneratedWarning?: boolean;
        typeAliases?: TypeAliases;
    });
    accountFilesByType(): Map<string, string>;
    customFilesByType(): Map<string, string>;
    resolveFieldType: (typeName: string) => import("./types").IdlTypeEnum | import("./types").IdlDefinedType | null;
    renderCode(): {
        instructions: Record<string, string>;
        accounts: Record<string, string>;
        types: Record<string, string>;
        errors: string | null;
    };
    renderAndWriteTo(outputDir: PathLike): Promise<void>;
    private writeInstructions;
    private writeAccounts;
    private writeTypes;
    private writeErrors;
    writeMainIndex(reexports: string[]): Promise<void>;
    private renderImportIndex;
}
